package provide DS9 1.0

proc DisplayPixelTable {} {
    global ds9
    global pixel

    set size 400

    if {[winfo exist $pixel(top)]} {
	DestroyPixelTable
    }
    
    # create the pixel table window

    set title "Pixel Table"
    set mb $pixel(mb)

    toplevel $pixel(top)
    wm title $pixel(top) $title
    wm iconname $pixel(top) $title
    wm group $pixel(top) $ds9(top)
    
    $pixel(top) configure -menu $mb

    # simple menus

    menu $mb -tearoff 0
    $mb add cascade -label File -menu $mb.file
    $mb add cascade -label Edit -menu $mb.edit

    menu $mb.file -tearoff 0
    $mb.file add command -label "Print..." \
	-command [list PrintPixelTable] -state disabled
    $mb.file add separator
    $mb.file add command -label "Close" -command [list DestroyPixelTable]

    menu $mb.edit -tearoff 0
    $mb.edit add command -label "Cut" -state disabled
    $mb.edit add command -label "Copy" -command [list CopyPixelTable]
    $mb.edit add command -label "Paste" -state disabled
    $mb.edit add command -label "Clear" -state disabled

    frame $pixel(top).f -width $size -height $size
    pack $pixel(top).f
}

proc DestroyPixelTable {} {
    global pixel
    
    destroy $pixel(top)
    destroy $pixel(mb).file
    destroy $pixel(mb).edit
    destroy $pixel(mb)
}

proc CopyPixelTable {} {
    global pixel

    clipboard clear -displayof $pixel(top)
    clipboard append -displayof $pixel(top) [selection get -displayof $pixel(top)]
}

proc PrintPixelTable {} {
    global pixel

    tk_messageBox -message "Sorry, Not Implemented." \
	-parent $pixel(top) -type ok -icon info
}

