#include <stdlib.h>
#include <string.h>

#include "colorscaletrue8.h"
#include "util.h"

ColorScaleTrueColor8::ColorScaleTrueColor8(int s,
					   unsigned long red,
					   unsigned long green,
					   unsigned long blue)
  : ColorScale(s)
{
  colors_ = new unsigned char[s];

  int rs,gs,bs;
  unsigned char rm = decodeMask((unsigned char)red, &rs);
  unsigned char gm = decodeMask((unsigned char)green, &gs);
  unsigned char bm = decodeMask((unsigned char)blue, &bs);

  for (int i=0; i<s; i++)
    colors_[i] =
      ((psColors_[i*3+2] & rm) >> rs) |  // red
      ((psColors_[i*3+1] & gm) >> gs) |  // green
      ((psColors_[i*3]   & bm) >> bs);   // blue
}

LinearScaleTrueColor8::LinearScaleTrueColor8(int s, 
					     unsigned short* indexCells,
					     unsigned char* colorCells,
					     int count,
					     unsigned long red,
					     unsigned long green,
					     unsigned long blue) 
  : LinearScale(s, indexCells, colorCells, count), 
    ColorScaleTrueColor8(s, red, green, blue),
    ColorScale(s) {}

LogScaleTrueColor8::LogScaleTrueColor8(int s,
				       unsigned short* indexCells,
				       unsigned char* colorCells,
				       int count,
				       unsigned long red,
				       unsigned long green,
				       unsigned long blue) 
  : LogScale(s, indexCells, colorCells, count), 
    ColorScaleTrueColor8(s, red, green, blue),
    ColorScale(s) {}

SquaredScaleTrueColor8::SquaredScaleTrueColor8(int s,
					       unsigned short* indexCells,
					       unsigned char* colorCells,
					       int count,
					       unsigned long red,
					       unsigned long green,
					       unsigned long blue) 
  : SquaredScale(s, indexCells, colorCells, count), 
    ColorScaleTrueColor8(s, red, green, blue),
    ColorScale(s) {}

SqrtScaleTrueColor8::SqrtScaleTrueColor8(int s,
					 unsigned short* indexCells,
					 unsigned char* colorCells,
					 int count,
					 unsigned long red,
					 unsigned long green,
					 unsigned long blue) 
  : SqrtScale(s, indexCells, colorCells, count), 
    ColorScaleTrueColor8(s, red, green, blue),
    ColorScale(s) {}

